/*
 * sx1280_def.h
 *
 *  Created on: 14.09.2017
 *      Author: AndreR
 */

#pragma once

#define CMD_GET_STATUS					0xC0
#define CMD_WRITE_REGISTER				0x18
#define CMD_READ_REGISTER				0x19
#define CMD_WRITE_BUFFER				0x1A
#define CMD_READ_BUFFER					0x1B
#define CMD_SET_SLEEP					0x84
#define CMD_SET_STANDBY					0x80
#define CMD_SET_FS						0xC1
#define CMD_SET_TX						0x83
#define CMD_SET_RX						0x82
#define CMD_SET_RXDUTYCYCLE				0x94
#define CMD_SET_CAD						0xC5
#define CMD_SET_TXCONTINUOUSWAVE		0xD1
#define CMD_SET_TXCONTINUOUSPREAMBLE	0xD2
#define CMD_SET_PACKETTYPE				0x8A
#define CMD_GET_PACKETTYPE				0x03
#define CMD_SET_RFFREQUENCY				0x86
#define CMD_SET_TXPARAMS				0x8E
#define CMD_SET_CADPARAMS				0x88
#define CMD_SET_BUFFERBASEADDRESS		0x8F
#define CMD_SET_MODULATIONPARAMS		0x8B
#define CMD_SET_PACKETPARAMS			0x8C
#define CMD_GET_RXBUFFERSTATUS			0x17
#define CMD_GET_PACKETSTATUS			0x1D
#define CMD_GET_RSSIINST				0x1F
#define CMD_SET_DIOIRQPARAMS			0x8D
#define CMD_GET_IRQSTATUS				0x15
#define CMD_CLR_IRQSTATUS				0x97
#define CMD_CALIBRATE					0x89
#define CMD_SET_REGULATORMODE			0x96
#define CMD_SET_SAVECONTEXT				0xD5
#define CMD_SET_AUTOTX					0x98
#define CMD_SET_AUTOFS					0x9E
#define CMD_SET_LONGPREAMBLE			0x9B
#define CMD_SET_UARTSPEED				0x9D
#define CMD_SET_RANGING_ROLE			0xA3

#define IRQ_RADIO_NONE						0x0000
#define IRQ_TX_DONE							0x0001
#define IRQ_RX_DONE							0x0002
#define IRQ_SYNCWORD_VALID					0x0004
#define IRQ_SYNCWORD_ERROR					0x0008
#define IRQ_HEADER_VALID					0x0010
#define IRQ_HEADER_ERROR					0x0020
#define IRQ_CRC_ERROR						0x0040
#define IRQ_RANGING_SLAVE_RESPONSE_DONE		0x0080
#define IRQ_RANGING_SLAVE_REQUEST_DISCARDED	0x0100
#define IRQ_RANGING_MASTER_RESULT_VALID		0x0200
#define IRQ_RANGING_MASTER_TIMEOUT			0x0400
#define IRQ_RANGING_SLAVE_REQUEST_VALID		0x0800
#define IRQ_CAD_DONE						0x1000
#define IRQ_CAD_DETECTED					0x2000
#define IRQ_RX_TX_TIMEOUT					0x4000
#define IRQ_PREAMBLE_DETECTED				0x8000
#define IRQ_RADIO_ALL						0xFFFF

#define PREAMBLE_LENGTH_04_BITS 0x00
#define PREAMBLE_LENGTH_08_BITS 0x10
#define PREAMBLE_LENGTH_12_BITS 0x20
#define PREAMBLE_LENGTH_16_BITS 0x30
#define PREAMBLE_LENGTH_20_BITS 0x40
#define PREAMBLE_LENGTH_24_BITS 0x50
#define PREAMBLE_LENGTH_28_BITS 0x60
#define PREAMBLE_LENGTH_32_BITS 0x70

#define MOD_SHAPING_BT_OFF 0x00
#define MOD_SHAPING_BT_1_0 0x10
#define MOD_SHAPING_BT_0_5 0x20

#define FLRC_BR_1_300_BW_1_2 0x45
#define FLRC_BR_1_040_BW_1_2 0x69
#define FLRC_BR_0_650_BW_0_6 0x86
#define FLRC_BR_0_520_BW_0_6 0xAA
#define FLRC_BR_0_325_BW_0_3 0xC7
#define FLRC_BR_0_260_BW_0_3 0xEB

#define FLRC_CR_1_2 0x00
#define FLRC_CR_3_4 0x02
#define FLRC_CR_1_0 0x04

#define FLRC_NO_SYNCWORD			0x00
#define FLRC_SYNCWORD_LENGTH_4_BYTE	0x04

#define PA_RAMP_02_US 0x00
#define PA_RAMP_04_US 0x20
#define PA_RAMP_06_US 0x40
#define PA_RAMP_08_US 0x60
#define PA_RAMP_10_US 0x80
#define PA_RAMP_12_US 0xA0
#define PA_RAMP_16_US 0xC0
#define PA_RAMP_20_US 0xE0

#define RX_MATCH_SYNCWORD_OFF	0x00
#define RX_MATCH_SYNCWORD_1		0x10
#define RX_MATCH_SYNCWORD_2		0x20
#define RX_MATCH_SYNCWORD_1_2	0x30
#define RX_MATCH_SYNCWORD_3		0x40
#define RX_MATCH_SYNCWORD_1_3	0x50
#define RX_MATCH_SYNCWORD_2_3	0x60
#define RX_MATCH_SYNCWORD_1_2_3	0x70

#define PACKET_LENGTH_FIXED		0x00
#define PACKET_LENGTH_VARIABLE	0x20

#define CRC_OFF		0x00
#define CRC_1_BYTES	0x10
#define CRC_2_BYTES	0x20
#define CRC_3_BYTES	0x30

#define PERIOD_TICK_SIZE_15625_NS	0x00
#define PERIOD_TICK_SIZE_62500_NS	0x01
#define PERIOD_TICK_SIZE_1000_US	0x02
#define PERIOD_TICK_SIZE_4000_US	0x03

#define PACKET_TYPE_GFSK		0x00
#define PACKET_TYPE_LORA		0x01
#define PACKET_TYPE_RANGING		0x02
#define PACKET_TYPE_FLRC		0x03
#define PACKET_TYPE_BLE			0x04
#define PACKET_TYPE_NONE		0x0F
